{% extends "crud.html" %}


{% block sub_head %}
    {% assets
        filters="cssrewrite, cssmin",
        output="compressed/datepicker.css",
        "css/plugins/bootstrap-datepicker.min.css"
    %}
        {{ mg.async_css(ASSET_URL) }}
    {% endassets %}
    {% assets
        filters="rjsmin",
        output="compressed/datepicker.js",
        "js/plugins/bootstrap-datepicker.min.js"
    %}
        {{ mg.js(ASSET_URL) }}
    {% endassets %}
    <style>
        .gray-bg {background-color: #f5f5f5}
    </style>
{% endblock %}


{% block top_records_navigation %}
    <div class="col"></div>
{% endblock %}


{% block datatable_filters %}
    <input type="hidden" data-datatable-filter="4" />
    <div class="col-12 col-md-4">
        <div class="input-group input-daterange">
            <input type="text" class="form-control" />
            <span class="input-group-addon">to</span>
            <input type="text" class="form-control" />
        </div>
    </div>
    <div class="col-12 col-md-4">
        <div class="form-group">
            <select class="form-control" data-datatable-filter="6">
                <option value="">All Statuses</option>
                <option value="0">Draft</option>
                <option value="1">Review Pending/Ongoing</option>
                <option value="-1">Void</option>
            </select>
        </div>
    </div>
{% endblock %}


{% block add_form %}
<div class="row">
    <div class="col-12 col-md-6">
        <div class="row">
            <div class="col-12">
                <div class="form-group">
                    <label>{{ "from_client"|normalize|title }}*</label>
                    <select name="client_from" class="form-control" data-ajax-select-target="/api/v1/clients/all?fields=name,business_type" data-ajax-select-value="_id" data-ajax-select-label="name,business_type" required placeholder="-- Select Client --">
                        <option value="">-- Select Client --</option>
                    </select>
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-12">
                <div class="form-group">
                    <label>{{ "for_client"|normalize|title }}*</label>
                    <select name="client_for" class="form-control" data-ajax-select-target="/api/v1/clients/all?fields=name,business_type" data-ajax-select-value="_id" data-ajax-select-label="name,business_type" required placeholder="-- Select Client --">
                        <option value="">-- Select Client --</option>
                    </select>
                </div>
            </div>
        </div>
    </div>
    <div class="col-12 col-md-6">
        <div class="row">
            <div class="col-12">
                <div class="form-group">
                    <label>{{ "date_delivered"|normalize|title }}*</label>
                    <input type="text" name="date_delivered" class="form-control datepicker" required />
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-12">
                <div class="form-group">
                    <label>{{ "receipt_no"|normalize|title }}*</label>
                    <input type="text" name="receipt_no" class="form-control" oninput="this.value = this.value.toUpperCase()" maxlength="32" required />
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-12">
                <div class="form-group">
                    <label>{{ "purchase_order_no"|normalize|title }}*</label>
                    <input type="text" name="purchase_order_no" class="form-control" oninput="this.value = this.value.toUpperCase()" maxlength="32" required />
                </div>
            </div>
        </div>
    </div>
</div>
<div class="row">
    <div class="col-12" data-item-container>
        <h5>Items</h5>
        <div class="row">
            <div class="col-12 col-md-3">
                <a class="btn btn-warning btn-sm btn-block" href="javascript:;" data-item-toggle="add"> <i class="fa fa-plus"></i> Add Item</a>
            </div>
        </div>
    </div>
</div>
{% endblock %}


{% block empty_spiel %}
    Add Delivery Receipts, details include
    <br />
    breakdown of delivered items, and client info
{% endblock %}


{% block read_columns %}
{# <script> #}
    {
        data: 'receipt_no',
        searchable: true,
        orderable: true,
        render: function(data, type) {
            if (type === 'sort') {
                return data;
            } else {
                return '<a href="javascript:;" data-crud-toggle="details" class="font-weight-bold" aria-expanded="true"> #{0}</a>'.format(data);
            }
        }
    },
    {
        data: 'purchase_order_no',
        searchable: true,
        orderable: true
    },
    {
        data: 'client_from',
        searchable: false,
        orderable: true,
        render: function(data) {
            return data.name;
        }
    },
    {
        data: 'client_for',
        searchable: false,
        orderable: true,
        render: function(data) {
            return data.name;
        }
    },
    {
        data: 'date_delivered',
        className: 'd-none d-sm-none d-md-table-cell',
        orderable: true
    },
    {
        data: 'date_created',
        className: 'd-none d-sm-none d-md-table-cell',
        searchable: false,
        orderable: true
    },
    {
        data: 'status',
        className: 'd-none d-sm-none d-md-none d-lg-none d-xl-table-cell',
        searchable: false,
        orderable: true,
        render: function(data, type) {
            if (type === 'sort') {
                return data;
            } else {
                switch(data) {
                    case 0:
                    return 'Draft';
                    case 1:
                    return 'Review Pending/Ongoing';
                    case 2:
                    return 'Completed';
                    case -1:
                    return 'Void';
                    default:
                    return 'N/A';
                }
            }
        }
    },
    {
        data: 'status',
        className: 'text-center',
        searchable: false,
        orderable: false,
        render: function(data, type, row) {
            switch (data) {
                case 0:
                    return '<a href="javascript:;" class="btn btn-success btn-sm btn-block" data-delivery-toggle="submit" data-submit-target="{0}"><i class="fa fa-check fa-fw"></i><span class="d-none d-sm-none d-md-inline"> Submit to QC/QA</span></a>'.format(row._id);
                default:
                    return '';
            }
        }
    },
    {
        data: '_id',
        sortable: false,
        className: 'text-center',
        render: function(data, type, row) {
            if (row.status === 0) {
                {% if session.user.access_levels.permissions.get(request.mod, {}).get('delete', False) %}
                return '<a href="javascript:;" class="btn btn-danger btn-sm btn-block" data-crud="delete" data-delete-target="{0}"><i class="fa fa-trash fa-fw"></i><span class="d-none d-sm-none d-md-inline"> Delete</span></a>'.format(data);
                {% else %}
                return '';
                {% endif %}
            }
            else {
                return '';
            }
        }
    }
{# </script> #}
{% endblock %}


{% block sub_scripts %}
{# <script> #}
    $dom.document.on('click', '[data-item-toggle="add"]', function() {
        $c = $(this).closest('[data-item-container]');
        color = ($c.find('.row').length%2) ? 'gray-bg' : '';
        $c.find('.row:last').after(`
            <div class="row {0}" data-form-dynamic>
                <div class="col-4 offset-8 col-md-3 offset-md-9">
                    <a href="javascript:;" class="btn btn-secondary btn-sm btn-block" data-item-toggle="delete"> Delete Item</a>
                </div>
                <div class="col-6 col-md-4">
                    <div class="form-group">
                        <label>Item Code*</label>
                        <select name="items-item_code" class="form-control" data-ajax-select-target="/api/v1/raw_materials/all?fields=item_code,description" data-ajax-select-value="_id" data-ajax-select-label="item_code,description" required placeholder="-- Select Item Code --">
                            <option value="">-- Select Item Code --</option>
                        </select>
                    </div>
                </div>
                <div class="col-6 col-md-4">
                    <div class="form-group">
                        <label>Quantity*</label>
                        <input type="number" name="items-quantity" class="form-control" min="0" step="0.0001" required />
                    </div>
                </div>
                <div class="col-6 col-md-4">
                    <div class="form-group">
                        <label>Price per Unit</label>
                        <input type="number" name="items-price_per_unit" class="form-control" min="0.01" step="0.01" />
                    </div>
                </div>
                <div class="col-6 col-md-4">
                    <div class="form-group">
                        <label>Expiry Date</label>
                        <input type="text" name="items-expiry_date" class="form-control datepicker" />
                    </div>
                </div>
                <div class="col-6 col-md-4">
                    <div class="form-group">
                        <label>Manufacturing Date</label>
                        <input type="text" name="items-manufacturing_date" class="form-control datepicker" />
                    </div>
                </div>
            </div>
        `.format(
            color
        ));
        $c.find('.row:last [data-ajax-select-target]').ajaxDropdown();
        $c.find('.row:last .datepicker').datepicker();
    });

    $dom.document.on('click', '[data-item-toggle="delete"]', function() {
        $c = $(this).closest('[data-item-container]');
        $self = $(this);
        Swal.fire({
            type: 'question',
            title: 'Delete Item',
            text: 'Unsaved information will be removed',
            showCancelButton: true,
            focusCancel: true,
            confirmButtonText: 'Yes'
        }).then((result) => {
            if (result.value) {
                $self.closest('.row[data-form-dynamic]').remove();
                $.each($c.find('.row[data-form-dynamic]'), function(i, v) {
                    $(v).removeClass('gray-bg');
                    if (i % 2 == 0) {
                        $(v).addClass('gray-bg');
                    }
                });
            }
        });
    });

    $dom.document.on('click', '[data-delivery-toggle="submit"]', function() {
        $self = $(this);
        Swal.fire({
            type: 'question',
            title: 'Submit to QC/QA?',
            text: 'Changes will not be accepted after submission',
            showCancelButton: true,
            focusCancel: true,
            confirmButtonText: 'Yes'
        }).then((result) => {
            if (result.value) {
                $.post('{{ url_for(".change_status", _id="placeholder") }}'.replace('placeholder', $self.attr('data-submit-target')), {'status': 1}, function() {})
                .done(function(response) {
                    if (isDefined(response.success) && response.success) {
                        Swal.fire('Submitted Successfully', '', 'success');
                    }
                    else {
                        Swal.fire('Error', response.error, 'error');
                    }
                })
                .always(function() {
                    $dom.datatables.records.reload('submit delivery');
                })
                .fail(function() {
                    Swal.fire('Error', 'Server Error', 'error');
                });
            }
        });
    });

    $dom.document.find('[name="date_delivered"].datepicker').datepicker();
    $dom.document.find('.input-daterange').datepicker({format: 'yyyy-mm-dd'}).on('changeDate', function(e) {
        range = '';
        $.each($(this).find('input'), function(i, v) {
            range += '{0}{1}'.format($(v).val(), (i>0)?'':',');
        })
        $dom.document.find('input[type="hidden"][data-datatable-filter=4]').val(range).trigger('input');
    });
{# </script> #}
{% endblock %}
